#include "stdafx.h"
#include "CApp.h"

class CTaskControlBase {
/**
	^XN̂߂̊NX
*/
public:
	void	setPriority(int nPriority) { nPriority_ = nPriority;}
	int		getPriority() { return nPriority_; }
	/*
		vCIeBi^XN̗Dxj̐ݒ^擾
		vCIeB̐ݒ莩̂́Aclass CTaskController ̑ōsȂ̂
		̔hNXsȂKv͂ȂB
	*/

	virtual void Task(void*) = 0;
	///	Ăяoׂ^XNBhNXŃI[o[Ch
	///	̈ɂ́ACTaskController::callTaskœn̂̂܂ܓĂ

protected:
	int		nPriority_;
};

class CTaskController {
/**
	^XÑRg[[
	CTaskControlBase*listĂĊǗ
*/
public:
	typedef list<CTaskControlBase*>	tasklist;
	tasklist* getTaskList() { return& tasklist_; }

	///	ׂẴ^XNĂяo
	void	callTask(void*p){
		tasklist::iterator it = getTaskList()->begin();
		bKillTask_ = false;
		while (it!=getTaskList()->end()){
			(*it)->Task(p);
			if (bKillTask_) {
				//	̃^XN͎
				bKillTask_ = false;
				delete *it;
				it = getTaskList()->erase(it);
			} else {
				it++;
			}
		}
	}

	/**
		^XN^XNXgɓo^
		new CTaskControlBasehNXnă`
		vCIeB́A^XN̗DxB0ƈԗD揇ʂB
		ɔă}CiX̒lnĂǂ悤ɂ͂ȂĂB
	*/
	void	addTask(CTaskControlBase*p,int nPriority)
	{
		p->setPriority(nPriority);
		tasklist::iterator it = getTaskList()->begin();
		while (it!=getTaskList()->end()){
			if ((*it)->getPriority() > nPriority) break;
			it++;
		}
		getTaskList()->insert(it,p);
	}

	/**
		Dxw肵āÃ^XNł
		(AŎ̃^XN폜邱Ƃ͏oȂ)
	*/
	void	killTask(int nPriority){
		tasklist::iterator it = getTaskList()->begin();
		while (it!=getTaskList()->end()){
			int nMyPriority = (*it)->getPriority();
			if (nMyPriority > nPriority) break;
			// priorityɊւĐł̂ŒĂ΂ł܂
			if (nMyPriority == nPriority) {
				delete *it;
				it = getTaskList()->erase(it);
			}
		}
	}

	/**
		Dxw肵ă^XNꊇ폜
		̃\bhĂяoƂÃ^XN܂܂Ă͂Ȃ
	*/
	void	killTask(int nStartPriority,int nEndPriority){
		tasklist::iterator it = getTaskList()->begin();
		while (it!=getTaskList()->end()
			&& ((*it)->getPriority()<nStartPriority)) ++it;
		while (it!=getTaskList()->end()
			&& ((*it)->getPriority()<nEndPriority)) {
			delete *it;
			it = getTaskList()->erase(it);
		}
	}

	/**
		callTaskŌĂяoĂ^XN
		g폜邽߂̃\bh
	*/
	void	killMe() { bKillTask_ = true; }

protected:
	tasklist tasklist_;
	bool	bKillTask_;
};

//	܂ł͔ėpIȃQ[^XNƃQ[^XNRg[[
//	KɂԂĎgă`
/////////////////////////////////////////////////////////////////
//	́ÃQ[p̃Q[^XNRg[[info

/**
	^XND揇ʂƂĂ̓^XNƂɈقȂlpӂ
*/
namespace taskPriority {
	enum TaskPriority__ { task1,task2,task3 };
}

struct CGameTaskInfo {
	CApp* getApp() { return pApp;}
	void  setApp(CApp*p){ pApp = p; }

	//	`悷ReLXg擾
	CFastPlane* getDrawContext()
	{ return getApp()->GetDraw()->GetSecondary(); }

	CTaskController* getTaskController() { return pTaskController;}
	void setTaskController(CTaskController*tc) { pTaskController=tc;}

	bool bMove;	//	ړ̂
	bool bDraw;	//	`悷̂

protected:
	CTaskController* pTaskController;
	CApp*		pApp;	//	̃AvNX
};

//	[U[`^XNNX
class CMyTask : public CTaskControlBase {
public:
	virtual void Task(void*p){
		CGameTaskInfo* pInfo = (CGameTaskInfo*)p;
		if (pInfo->bMove) OnMove(pInfo);
		if (pInfo->bDraw) OnDraw(pInfo);
	}
	virtual void OnMove(CGameTaskInfo* p){}
	virtual void OnDraw(CGameTaskInfo* p){}
	/*
		[U[͂̃NXhA
		OnMoveOnDrawI[o[ChĎg
	*/

	//	g̃^XN(^XNRg[[̗͂؂)
	virtual void killMe(CGameTaskInfo* p){
		p->getTaskController()->killMe();
	}

	//	قA^XNRg[[ւ̃ANZX
	//	̃NXœKwrapƗǂ
};

struct CMyTask2 : public CMyTask {
	CMyTask2() : n_(0) {}
	virtual void OnMove(CGameTaskInfo* p){
		CDbg().Out("CMyTask2::OnMove");
		n_++;
		if (n_==4) {
			CDbg().Out("Ԃ̂Task2Ȃɂ(LD`)");
			killMe(p);
		}
	}
	int n_;
};

//	[U[`^XNNX
struct CMyTask1 : public CMyTask {
	CMyTask1() : n_(0) {}
	virtual void OnMove(CGameTaskInfo* p){
		CDbg().Out("CMyTask1::OnMove");
		n_ ++;
		if (n_==3) {
			CDbg().Out("Task1Task2𐶐ɂ偛(ށ)o");
			p->getTaskController()->addTask(new CMyTask2,taskPriority::task2);
		}
		if (n_==5) {
			CDbg().Out("Ԃ̂Task1͂Ȃɂ(LD`)");
			killMe(p);
		}
	}
	int n_;
};

void	CApp::MainThread() {				 //	 ꂪs

	CTaskController tc;
	CGameTaskInfo info;
	info.setApp(this);
	info.setTaskController(&tc);
	//	P^XNN
	tc.addTask(new CMyTask1,taskPriority::task1);
	int count=0;
	while (IsThreadValid()){
		if (count<10) { count++; CDbg().Out("--callTask--"); }
		info.bMove = true;
		info.bDraw = false;
		tc.callTask(&info);
		//	Ń^XNĂяo
	}
}

//	ꂪmain windoŵ߂̃NXB
class CAppMainWindow : public CAppBase {	//	AvP[VNXh
	virtual void MainThread(void){			//	ꂪ[J[Xbh
		CApp().Start();						//	CApp app; app.Start();̈Ӗ
	}
};

//	킸ƒmꂽWinMain
int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	CAppInitializer init(hInstance,hPrevInstance,lpCmdLine,nCmdShow);	//	KĂ
	CSingleApp sapp;
	if (sapp.IsValid()) {
		CThreadManager::CreateThread(new CAppMainWindow());					//	Œ`C̃EBhD쐬
	}
	return 0;
}
